/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.annotation;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.base.model.element.IAnnotatedSpecification;
import org.fortiss.tooling.base.model.element.IModelElement;
import org.fortiss.tooling.kernel.service.base.IEObjectAware;

/**
 * Interface for {@link IAnnotatedSpecification}s
 * 
 * @author eder
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash:
 */
public interface IAnnotationValueProvider<T extends IAnnotatedSpecification> extends
		IEObjectAware<IModelElement> {

	// List<Annotation> annotations = new ArrayList<Annotation>();

	/** Returns the specific value */
	public String getValue(T specification);

	public void setValue(String value, T specification);

	/** Returns the specific type of T */
	// public Class<? extends IAnnotatedSpecification> getAnnotatedSpecClazz();

	public T addNewSpecToModelElement(IModelElement element);

	public Class<T> getClazz();

	public String getAnnotationName();

	public List<Class<? extends EObject>> filterOut();

}
